﻿Imports C1.C1Schedule
Imports C1.Silverlight.Schedule

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
        cmbView.Items.Add("Day")
        cmbView.Items.Add("WorkingWeek")
        cmbView.Items.Add("Week")
        cmbView.Items.Add("Month")
        cmbView.Items.Add("TimeLine")
        cmbView.SelectedIndex = 3

        Dim app As New Appointment(DateTime.Today.AddHours(12), TimeSpan.FromHours(1))
        app.Subject = "Progress Meeting"
        c1Scheduler1.DataStorage.AppointmentStorage.Appointments.Add(app)


        app = New Appointment(DateTime.Today.AddHours(14), TimeSpan.FromHours(3))
        app.Subject = "Product Meeting"
        app.Body = "A meeting about new products"
        c1Scheduler1.DataStorage.AppointmentStorage.Appointments.Add(app)

        app = New Appointment(DateTime.Today.AddHours(10), TimeSpan.FromMinutes(15))
        app.Subject = "Silverlight Study Session"
        c1Scheduler1.DataStorage.AppointmentStorage.Appointments.Add(app)

    End Sub

    Dim lst As New List(Of VisualIntervalPresenter)()

    Private Sub SelectVisualInterval(point As Point)
        ClearVisualIntervals()

        Dim location As Point = point
        lst.Clear()
        'Get the right clicked Interval and select it
        Dim el As VisualIntervalPresenter = GetUIElement(c1Scheduler1, location)

        If el IsNot Nothing Then
            el.Interval.IsSelected = True
            lst.Add(el)
        End If
    End Sub

    Private Sub ClearVisualIntervals()
        For i As Integer = 0 To c1Scheduler1.GroupItems.Count - 1
            For Each vi In c1Scheduler1.GroupItems(i).VisualIntervals
                vi.IsSelected = False
            Next
        Next
    End Sub

    Public Shared Function GetUIElement(sched As C1Scheduler, location As Point) As VisualIntervalPresenter
        Dim els As IEnumerable(Of UIElement)

        'Finds all elements in host coordinates and returns the matched VisualIntervalPresenter
        Try
            els = VisualTreeHelper.FindElementsInHostCoordinates(location, sched)
            For Each el As UIElement In els
                If TypeOf el Is VisualIntervalPresenter Then
                    Return DirectCast(el, VisualIntervalPresenter)
                End If
            Next
        Catch
        End Try

        Return Nothing
    End Function


    Private Sub cmbView_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles cmbView.SelectionChanged
        Select Case DirectCast(cmbView.SelectedItem, String)
            Case "Month"
                c1Scheduler1.ChangeStyle(c1Scheduler1.MonthStyle)
                Exit Select
            Case "Day"
                c1Scheduler1.ChangeStyle(c1Scheduler1.OneDayStyle)
                Exit Select
            Case "WorkingWeek"
                c1Scheduler1.ChangeStyle(c1Scheduler1.WorkingWeekStyle)
                Exit Select
            Case "Week"
                c1Scheduler1.ChangeStyle(c1Scheduler1.WeekStyle)
                Exit Select
            Case "TimeLine"
                c1Scheduler1.ChangeStyle(c1Scheduler1.TimeLineStyle)
                Exit Select
        End Select

    End Sub

    Private Sub c1Scheduler1_MouseLeftButtonUp(sender As Object, e As System.Windows.Input.MouseButtonEventArgs) Handles c1Scheduler1.MouseLeftButtonUp
        For Each vp As VisualIntervalPresenter In lst
            If vp.Interval IsNot Nothing Then
                vp.Interval.IsSelected = False
            End If
        Next

        lst.Clear()

        If c1Scheduler1.SelectedVisualInterval IsNot Nothing Then
            c1Scheduler1.SelectedVisualInterval.IsSelected = True
        End If

    End Sub

    Private Sub c1Scheduler1_MouseRightButtonDown(sender As Object, e As System.Windows.Input.MouseButtonEventArgs) Handles c1Scheduler1.MouseRightButtonDown
        Dim location As New Point
        location = e.GetPosition(Me)
        SelectVisualInterval(location)
    End Sub

    Private Sub c1Scheduler1_StyleChanged(sender As Object, e As System.Windows.RoutedEventArgs) Handles c1Scheduler1.StyleChanged
        If c1Scheduler1.Style Is c1Scheduler1.WorkingWeekStyle Then
            cmbView.SelectedIndex = 1
        ElseIf c1Scheduler1.Style Is c1Scheduler1.WeekStyle Then
            cmbView.SelectedIndex = 2
        ElseIf c1Scheduler1.Style Is c1Scheduler1.MonthStyle Then
            cmbView.SelectedIndex = 3
        ElseIf c1Scheduler1.Style Is c1Scheduler1.TimeLineStyle Then
            cmbView.SelectedIndex = 4
        Else
            cmbView.SelectedIndex = 0
        End If

    End Sub
End Class